{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
unit Unit1;

interface

{$IFDEF KOL_MCK}
uses Windows, Messages, KOL {$IFNDEF KOL_MCK}, mirror, Classes, Controls, mckControls, mckObjs, Graphics,
  mckCtrls {$ENDIF (place your units here->)}, err;
{$ELSE}
{$I uses.inc}
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, mirror;
{$ENDIF}

type
  {$IFDEF KOL_MCK}
  {$I MCKfakeClasses.inc}
  {$IFDEF KOLCLASSES} {$I Form1class.inc} {$ELSE OBJECTS} PForm1 = ^TForm1; {$ENDIF CLASSES/OBJECTS}
  {$IFDEF KOLCLASSES}{$I TForm1.inc}{$ELSE} TForm1 = object(TObj) {$ENDIF}
    Form: PControl;
  {$ELSE not_KOL_MCK}
  TForm1 = class(TForm)
  {$ENDIF KOL_MCK}
    KOLProject1: TKOLProject;
    KOLForm1: TKOLForm;
    ListView1: TKOLListView;
    Button1: TKOLButton;
    procedure KOLForm1FormCreate(Sender: PObj);
    function ListView1LVCustomDraw(Sender: PControl; DC: HDC;
      Stage: Cardinal; ItemIdx, SubItemIdx: Integer; const Rect: TRect;
      ItemState: TDrawState; var TextColor, BackColor: Integer): Cardinal;
    function KOLForm1Message(var Msg: tagMSG; var Rslt: Integer): Boolean;
    function ListView1Message(var Msg: tagMSG; var Rslt: Integer): Boolean;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1 {$IFDEF KOL_MCK} : PForm1 {$ELSE} : TForm1 {$ENDIF} ;

{$IFDEF KOL_MCK}
procedure NewForm1( var Result: PForm1; AParent: PControl );
{$ENDIF}

implementation

uses JpegObj;

{$IFNDEF KOL_MCK} {$R *.DFM} {$ENDIF}

{$IFDEF KOL_MCK}
{$I Unit1_1.inc}
{$ENDIF}

procedure TForm1.KOLForm1FormCreate(Sender: PObj);
begin
  ListView1.LVCount := 2;
end;

function TForm1.ListView1LVCustomDraw(Sender: PControl; DC: HDC;
  Stage: Cardinal; ItemIdx, SubItemIdx: Integer; const Rect: TRect;
  ItemState: TDrawState; var TextColor, BackColor: Integer): Cardinal;
var Txt: String;
    R, R1: TRect;

    procedure ProvideColors;
    begin
      if odsSelected in ItemState then
      begin
        if Sender.Focused then
        begin
          Sender.Canvas.Brush.Color := clNavy;
          Sender.Canvas.Font.Color := clYellow;
        end
          else
        begin
          Sender.Canvas.Brush.Color := Color2RGB( clBtnFace );
          Sender.Canvas.Font.Color := clRed;
        end;
      end
        else
      begin
        Sender.Canvas.Brush.Color := clWindow;
        Sender.Canvas.Font.Color := clBlue;
      end;
      Sender.Canvas.DeselectHandles;
    end;

var i, j: Integer;
begin
  if LongBool(Stage = (CDDS_PREPAINT or CDDS_SUBITEM)) and (ItemIdx >= 0) then
  begin
      Result := CDRF_SKIPDEFAULT;
      R := Sender.LVItemRect( ItemIdx, lvipBounds );
      if R.Bottom < 0 then Exit;
      for i := 0 to ListView1.LVColCount-1 do
      begin
        R1 := R;
        for j := 0 to i-1 do
          inc( R1.Left, Sender.LVColWidth[ j ] );
        R1.Right := R1.Left + Sender.LVColWidth[ i ];
        Txt := 'Item' + Int2Str( ItemIdx ) + '.' + Int2Str( i );
        ProvideColors;
        Sender.Canvas.TextRect( R1, R1.Left, R1.Top, Txt );
      end;
      Sender.Canvas.Brush.Color := clWindow;
      Sender.Canvas.Font.Color := clWindowText;
  end
    else
    Result := CDRF_NOTIFYITEMDRAW;
end;

function TForm1.KOLForm1Message(var Msg: tagMSG;
  var Rslt: Integer): Boolean;
begin
  Result := FALSE;
   if (Msg.message = WM_LBUTTONDOWN) and (Msg.hwnd = Form.Handle) then begin
     form.Perform(WM_NCLBUTTONDOWN, HTCAPTION, Msg.lParam);
     Result:= True; 
   end;
end;

function TForm1.ListView1Message(var Msg: tagMSG;
  var Rslt: Integer): Boolean;
var NMHdr: PNMHdr;
begin
  Result := FALSE;
  CASE Msg.message OF
  WM_NOTIFY:
    begin
      NMHdr := Pointer( Msg.lParam );
      if NMHdr.code = NM_CUSTOMDRAW then
      begin
        Rslt := CDRF_DODEFAULT;
        Result := TRUE;
      end;
    end;
  END;
end;

end.


